unit hiFormatStrMArray;

interface

uses Kol,Share,Debug, Windows;

type
  THIFormatStrMArray = class(TDebug)
   private
    FStr,substr:string;
    FDataCount:integer;
	FItem:TData;
    function TestRep(P:integer):boolean;
    procedure SetCount(Value:integer);
   public
    Str:array of THI_Event;
    _prop_Mask:string;
	_data_Array:THI_Event;
	_prop_Shift:integer;

    _event_onFString:THI_Event;
	
	

    procedure _work_doString(var _Data:TData; Index:word);
    procedure _work_doMask(var _Data:TData; Index:word);
    procedure _var_FString(var _Data:TData; Index:word);
    property _prop_DataCount:integer write SetCount;
  end;

implementation

procedure THIFormatStrMArray.SetCount;
begin
   SetLength(Str,Value);
   FDataCount := Value;
end;

function THIFormatStrMArray.TestRep(P:integer):boolean;
begin
//  Result := false;
  Result :=  not (FStr[P+length(substr)] in ['0'..'9']);
end;

procedure THIFormatStrMArray._work_doString;
var i:integer;
j:integer;
  Arr:PArray;
  Ind:TData;
begin


//MessageBox(ReadHandle,PChar(Arr),'Test',MB_OK);
//MessageBox(ReadHandle,PChar(ToString(ReadData(_Data,_data_Array))),'Test',MB_OK);
//MessageBox(ReadHandle,PChar(ToString(_Data)),'Test',MB_OK);
  
  FStr := _prop_Mask;
  Replace(FStr,'%%',#0);
  for i := 1 to FDataCount do begin
	Arr := ReadArray(Str[i-1]);
	if Arr<>nil then
		for j := 0 to Arr._Count-1 do begin
			substr := '%'+int2str(i)+'.'+int2str(j+_prop_Shift);
			dtInteger(Ind, j);
			Arr._Get(ind,FItem);
			Replace(FStr,substr,#1+ToString(FItem),TestRep);
		end
	else
		begin
		substr := '%'+int2str(i);
		Replace(FStr,substr,#1+ReadString(_Data,Str[i-1]),TestRep);
		end;
  end;
  Replace(FStr,#1,'');
  Replace(FStr,#0,'%');
  
  if Arr<>nil then		//  ,   
  begin
	Replace(FStr,'$$',#0);
	for i := 0 to Arr._Count do begin
		dtInteger(Ind, i);
		Arr._Get(ind,FItem); 
		substr := '$'+int2str(i);
		Replace(FStr,substr,#1+ToString(FItem),TestRep);
	end;
	Replace(FStr,#1,'');
	Replace(FStr,#0,'$');
  end;  
  
  _hi_CreateEvent(_Data,@_event_onFString,FStr);
end;

procedure THIFormatStrMArray._work_doMask(var _Data:TData; Index:word);
begin
   _prop_Mask := ToString(_Data);
end;

procedure THIFormatStrMArray._var_FString(var _Data:TData; Index:word);
begin
   dtString(_Data,FStr);
end;

end.
